//+------------------------------------------------------------------+
//|                                               SUSAN BLUETECH.mq5 |
//|                                  Copyright 2022, MetaQuotes Ltd. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2022, MetaQuotes Ltd."
#property link      "https://www.mql5.com"
#property version   "1.00"
//+------------------------------------------------------------------+
//|                                              susan_blue_tech.mq5 |
//|                                  Copyright 2022, MetaQuotes Ltd. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
#include <Trade\Trade.mqh>
#include <Trade\PositionInfo.mqh>
#include <Trade\Orderinfo.mqh>

#define BtnPaused "buttton_paused"

enum direction
  {
   Up,
   Down
  };




input group " PROVIDE YOUR NAME " // YOUR NAME IS REQUIRED FOR EA TO KNOW ITS USER
input string NAME=" ";// YOUR NAME IS REQUIRED FOR THE EA TO KNOW ITS USER


input group "=== MARKET DIRECTION MA SETTINGS=="
input int direction_ma_bars=200;
input ENUM_MA_METHOD direction_ma_method =MODE_SMA;
input ENUM_APPLIED_PRICE direction_ma_applied_price=PRICE_CLOSE;


input group"SIXTY MA SETTINGS"
input int sixty_ma_period =60;
input ENUM_MA_METHOD sixty_ma_method =MODE_EMA;
input ENUM_APPLIED_PRICE sixty_ma_applied_price=PRICE_CLOSE;
input color twentyfour_macolor=clrBlue;



input group"FOUR MA SETTINGS"
input int four_ma_period =4;
input ENUM_MA_METHOD four_ma_method =MODE_SMA;
input ENUM_APPLIED_PRICE four_ma_applied_price=PRICE_CLOSE;
input color four_macolor=clrBlue;

input group"EIGHT MA SETTINGS"
input int eight_ma_period =8;
input ENUM_MA_METHOD eight_ma_method =MODE_SMA;
input ENUM_APPLIED_PRICE eight_ma_applied_price=PRICE_CLOSE;
input color eight_macolor=clrBlue;

input group"TWELVE MA SETTINGS"
input int twelve_ma_period =12;
input ENUM_MA_METHOD twelve_ma_method =MODE_SMA;
input ENUM_APPLIED_PRICE twelve_ma_applied_price=PRICE_CLOSE;
input color twelve_macolor=clrBlue;

input group"SIXTEEN MA SETTINGS"
input int sixteen_ma_period =16;
input ENUM_MA_METHOD sixteen_ma_method =MODE_SMA;
input ENUM_APPLIED_PRICE sixteen_ma_applied_price=PRICE_CLOSE;
input color sixteen_macolor=clrBlue;

input group"TWENTY MA SETTINGS"
input int twenty_ma_period =20;
input ENUM_MA_METHOD twenty_ma_method =MODE_SMA;
input ENUM_APPLIED_PRICE twenty_ma_applied_price=PRICE_CLOSE;
input color twenty_macolor=clrBlue;

input group"TWENTYFOUR MA SETTINGS"
input int twentyfour_ma_period =24;
input ENUM_MA_METHOD twentyfour_ma_method =MODE_SMA;
input ENUM_APPLIED_PRICE twentyfour_ma_applied_price=PRICE_CLOSE;


input group"MACD SETTINGS"
input int macd_masignal_period =9;
input int macdfast_ma_period =12;
input int macdslow_ma_period =26;
input ENUM_APPLIED_PRICE macd_ma_applied_price=PRICE_CLOSE;




input group "GOD_ZONES SETTINGS"
int Levels = 1; // Levels - number of level zones in each direction.
input int Interval = 1000; // GOD_ZONES.
int ZoneWidth = 10; // Zone width in points.
input color ColorUp = clrPurple;
input color ColorDn = clrPurple;
input bool InvertZones = false; // Invert zones to shade the areas between round numbers.
input bool DrawLines = true; // Draw lines on levels.
color LineColor = clrDarkGray;
int LineWidth = 1;
ENUM_LINE_STYLE LineStyle = STYLE_DASHDOT;
string ObjectPrefix = "   GodZones";

//----------ROUND NUMBER INFO
int Entry=10;
double BUY_PRICE,SELL_PRICE,UpperLevel,LowerLevel;
int INTERVALS,Etr;

input int  startradingtime_in_hours=7;
input int  startradingtime_in_minutes= 10;

input int stoptradingtime_in_hours=22;
input int stoptradingtime_in_minutes=10;

string currenttime;
bool  tradingallowed=false;

input group"close at opposite signal"
input bool Use_close_opposite=true;

input group "TRADE SETTINGS"
input double ordersize=1.00;
input int ea_magic=2004;
input double stoploss=20;


input group "BRAKE EVEN SETTINGS"
input bool USE_BRAKEEVEN=true;
input int whentobreak=50;
input int breakby=5;

input group "TRAILLING STOPLOSS SETTINGS"
input bool USE_TRAILLING_SL=true;
input int whentotrail=200;
input int trailby=20;

//----button settings
bool ButtonState=true;///----trading on oor off,true==trade
//----when running
const  string buttontextrunning="RUNNING";
const int buttoncolourrunning=clrRed;
//----when paused
const string buttontextpause="PAUSED";
const int buttoncolourpaused=clrBlue;
string objectname=BtnPaused;



//-------------INFO ON BRAKEEVEN,TRAIL,TP,STP

double When_To_Break,Break_By,WHEN_TO_TRAIL, TRAIL_BY,modified_sl,modified_sl2,WEN_TO_BRAKEEVEN_PRICE,low,high,STP ;


//---------ARRAYS FOR INDICATORS
double direction_mabuffer[],four_mabuffer[],eight_mabuffer[],twelve_mabuffer[],sixteen_mabuffer[],twenty_mabuffer[],twentyfour_mabuffer[],closing_buffer[],macd_buffer[],signal_line[],BID,ASK;

//----------------HANDLES
int directionHandle,fourHandle,eightHandle,twelveHandle,sixteenHandle,twentyHandle,twentyfourHandle,closingHandle,macdHandle;

int  LastBars=0;
double TrailPrice,lot_size;
int stop_level,spread;


CTrade trade;
COrderInfo orderinfo;
CPositionInfo positionInfo;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int OnInit()
  {
//---


   TesterHideIndicators(false);
   CreateButton(0,100,50,100,20);
   ChartRedraw();

string us30="indices";
if(_Symbol!="#US30")
{
Alert("THE EA IS DESIGNED FOR US30 ALSO NASDAQ AND GER30");
return INIT_FAILED;
}





   trade.SetExpertMagicNumber(ea_magic);
   directionHandle=iMA(_Symbol,PERIOD_H1,direction_ma_bars,0,direction_ma_method,direction_ma_applied_price);
   closingHandle=iMA(_Symbol,PERIOD_H1,sixty_ma_period,0,sixty_ma_method,sixty_ma_applied_price);
   fourHandle=iMA(_Symbol,PERIOD_H1,four_ma_period,0,four_ma_method,four_ma_applied_price);
   eightHandle=iMA(_Symbol,PERIOD_H1,eight_ma_period,0,eight_ma_method,eight_ma_applied_price);
   twelveHandle=iMA(_Symbol,PERIOD_H1,twelve_ma_period,0,twelve_ma_method,twelve_ma_applied_price);
   sixteenHandle=iMA(_Symbol,PERIOD_H1,sixteen_ma_period,0,sixteen_ma_method,sixteen_ma_applied_price);
   twentyHandle=iMA(_Symbol,PERIOD_H1,twenty_ma_period,0,twenty_ma_method,twenty_ma_applied_price);
   twentyfourHandle=iMA(_Symbol,PERIOD_H1,twentyfour_ma_period,0,twentyfour_ma_method,twentyfour_ma_applied_price);
   macdHandle=iMACD(_Symbol,PERIOD_H1,macdfast_ma_period,macdslow_ma_period,macd_masignal_period,macd_ma_applied_price);


//################
///vaildate the handles
//#################


   if(directionHandle==INVALID_HANDLE||closingHandle==INVALID_HANDLE
      ||fourHandle==INVALID_HANDLE||eightHandle==INVALID_HANDLE
      ||twelveHandle==INVALID_HANDLE||sixteenHandle==INVALID_HANDLE||
      twentyHandle==INVALID_HANDLE||twentyfourHandle==INVALID_HANDLE
      ||macdHandle==INVALID_HANDLE)
      return(INIT_FAILED);








//##############
//placing the idexing of candles in the correct way
//##############

   ArraySetAsSeries(direction_mabuffer,true);
   ArraySetAsSeries(closing_buffer,true);
   ArraySetAsSeries(four_mabuffer,true);
   ArraySetAsSeries(eight_mabuffer,true);
   ArraySetAsSeries(twelve_mabuffer,true);
   ArraySetAsSeries(sixteen_mabuffer,true);
   ArraySetAsSeries(twenty_mabuffer,true);
   ArraySetAsSeries(twentyfour_mabuffer,true);
   ArraySetAsSeries(macd_buffer,true);
   ArraySetAsSeries(signal_line,true);





//handling calcutions

   When_To_Break=whentobreak*100*_Point;
   Break_By=breakby*100*_Point;
   INTERVALS = Interval*10;
   Etr=Entry;
   STP=stoploss*_Point*100;
   WHEN_TO_TRAIL=whentotrail*_Point*100;
   TRAIL_BY=NormalizeDouble(WHEN_TO_TRAIL-trailby*_Point,_Digits);
   lot_size=ordersize;


//  ########################
//handle_lotsize
//########################


   lot_size=(int)(lot_size/SymbolInfoDouble(_Symbol,SYMBOL_VOLUME_STEP))*SymbolInfoDouble(_Symbol,SYMBOL_VOLUME_STEP);
   lot_size=MathMin(lot_size,SymbolInfoDouble(_Symbol,SYMBOL_VOLUME_MAX));
   lot_size=MathMax(lot_size,SymbolInfoDouble(_Symbol,SYMBOL_VOLUME_MIN));



   Alert("Greetings"+NAME+" I wanted to constantly remind YOU ,i made this ea for you ,in times of losses be still ,stay calm ,the ea knows its job");

//---
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
   ObjectDelete(0,objectname);
   ClosePositions(POSITION_TYPE_BUY);
   ClosePositions(POSITION_TYPE_SELL);
   DeleteBuyOrders();
   DeleteOrders();
   IndicatorRelease(directionHandle);
   IndicatorRelease(closingHandle);
   IndicatorRelease(fourHandle);
   IndicatorRelease(eightHandle);
   IndicatorRelease(twelveHandle);
   IndicatorRelease(sixteenHandle);
   IndicatorRelease(twentyHandle);
   IndicatorRelease(twentyfourHandle);
   IndicatorRelease(macdHandle);








  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {


   if(!IsTradingAllowed()&& SymbolInfoInteger(_Symbol,SYMBOL_TRADE_MODE)!=SYMBOL_TRADE_MODE_FULL
      && SymbolInfoInteger(_Symbol,SYMBOL_TRADE_MODE)!=SYMBOL_TRADE_MODE_DISABLED)
     {
      return;
     }
   if(!IsMarkertOpen(Symbol(),TimeCurrent()))
      return;

   if((bool)MQLInfoInteger(MQL_VISUAL_MODE)&&(bool)MQLInfoInteger(MQL_TESTER))
     {
      SetButtonState(ObjectGetInteger(0,objectname,OBJPROP_STATE,0));
     }




   if(!ButtonState)//pausing of the ea
      return;

//-#######################
//PROCESS Y7YYY

   int newBar = Bars(_Symbol,PERIOD_H1);
   if(LastBars != newBar)
     {
      LastBars = newBar;
     }
   else
     {
      return;
     }







//########################
//----Symbol properties
//########################

   double starting_price = NormalizeDouble(SymbolInfoDouble(_Symbol, SYMBOL_BID), _Digits);
   BID=SymbolInfoDouble(_Symbol,SYMBOL_BID);
   ASK=SymbolInfoDouble(_Symbol,SYMBOL_ASK);


//################
//COPY INDICATOR BUFFER DATA TO ARRAYS
//#############
   CopyBuffer(directionHandle,0,0,4,direction_mabuffer);
   CopyBuffer(closingHandle,0,0,4,closing_buffer);
   CopyBuffer(fourHandle,0,0,4,four_mabuffer);
   CopyBuffer(eightHandle,0,0,4,eight_mabuffer);
   CopyBuffer(twelveHandle,0,0,4,twelve_mabuffer);
   CopyBuffer(sixteenHandle,0,0,4,sixteen_mabuffer);
   CopyBuffer(twentyHandle,0,0,4,twenty_mabuffer);
   CopyBuffer(twentyfourHandle,0,0,4,twentyfour_mabuffer);
   CopyBuffer(macdHandle,MAIN_LINE,0,4,macd_buffer);
   CopyBuffer(macdHandle,SIGNAL_LINE,0,4,signal_line);







//#################################
//---caclculation of roundnumbers
//##################################

   for(int i = 0; i < Levels; i++)//this will never be false 1+2+3+4+5+6+7+8+9
     {
      // Calculate price levels below and above the current price.
      LowerLevel= FindNextLevel(NormalizeDouble(starting_price + i * INTERVALS, _Digits),Down);
      UpperLevel= FindNextLevel(NormalizeDouble(starting_price - i * INTERVALS, _Digits),Up);

      // Calculate and draw rectangle below current price.
      string name;

      name = ObjectPrefix + "LD" + IntegerToString(i);
      if(DrawLines)
         DrawLine(name, LowerLevel,ColorDn);

      name = ObjectPrefix + "LU" + IntegerToString(i);
      if(DrawLines)
         DrawLine(name, UpperLevel,ColorUp);
     }

//####################
//calculate entry price at every tick received N add to roundnumber
//####################

   BUY_PRICE=UpperLevel+Entry;
   BUY_PRICE=NormalizeDouble(BUY_PRICE,Digits());
   SELL_PRICE=LowerLevel-Entry;
   SELL_PRICE=NormalizeDouble(SELL_PRICE,Digits());

//##############
//brake even and trailling_sl
//##############


   if(PositionsTotal()>0)
     {
      if(USE_BRAKEEVEN)
         BrakeEven();

      if(USE_TRAILLING_SL)
         TrailingStopLoss();
     }




//#################################
//ENTRY CONDITIONS
//################################

   if(ASK>direction_mabuffer[1]&&ASK>closing_buffer[1])////---dont forgert twenty four
     {
      if(NumOfBuy()==0)
        {
         //  if(BullIsTrending())
         //{
         if(TimeFilter())
           {
            PlaceBuyOrder();
            //    }
           }
        }


     }
   if(Use_close_opposite)
     {
      if(BID<closing_buffer[1]&&BearMaCrossOver())
        {
         ClosePositions(POSITION_TYPE_BUY);
        }
     }

   if(ASK<direction_mabuffer[1]&&ASK<closing_buffer[1])
     {
      if(NumoFSell()==0)
        {
         if(TimeFilter())
           {
            // if(BearIsTrending())
            //  {
            PlaceSellOrder();
            // }
           }
        }

     }
   if(Use_close_opposite)
     {
      if(BID>closing_buffer[1]&&BullMaCrossOver())
        {
         ClosePositions(POSITION_TYPE_SELL);
        }
     }















//#########
//DELETE ORDERS IF THER IS AN OPEN POSITIONS
///########




   DeleteOrders();

   if(NumOfBuyOrders()>0&&BullIsTrending()==false)
     {
      DeleteBuyOrders();
     }
   if(NumOfSellOrders()>0&&BearIsTrending()==false)
     {
      DeleteSellOrders();
     }




//trading allowed curren stop strarttradi
   Comment("\ntimefilter"," ",TimeFilter()," ",
           "\ntimelocal "," ",TimeLocal()
          );

   ;


  }



//+------------------------------------------------------------------+
//| on chart event for the end user of the ea
//+------------------------------------------------------------------+
void  OnChartEvent(
   const int       id,       // event ID
   const long&     lparam,   // long type event parameter
   const double&   dparam,   // double type event parameter
   const string&   sparam    // string type event parameter
)
  {
   if(sparam!=objectname)
      return;
   if(id!=CHARTEVENT_OBJECT_CLICK)
      return;

   SetButtonState(ObjectGetInteger(0,objectname,OBJPROP_STATE,0));/////------THIS GETS THE STATE OF THE BUTTON//CLICKED OR NOT
   if(sparam== objectname)
     {
      ClosePositions(POSITION_TYPE_BUY);
      ClosePositions(POSITION_TYPE_SELL);
      DeleteBuyOrders();
      DeleteSellOrders();
     }


  }



//+------------------------------------------------------------------+
//| roundnumber function                                             |
//+------------------------------------------------------------------+
double FindNextLevel(const double sp, const direction dir)
  {
// Multiplier for getting number of points in the price.
   double multiplier = MathPow(10, _Digits);
// Integer price (nubmer of points in the price).
   int integer_price = (int)MathRound(sp * MathPow(10, _Digits));
// Distance from the next round number down.
   int distance = integer_price % INTERVALS;
   if(dir == Down)
     {
      return(NormalizeDouble(MathRound(integer_price - distance) / multiplier, _Digits));
     }
   else
      if(dir == Up)
        {
         return(NormalizeDouble((integer_price + (INTERVALS - distance)) / multiplier, _Digits));
        }
   return(EMPTY_VALUE);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void DrawLine(const string name, const double price, const color Color)
  {
   if(ObjectFind(0, name) < 0)
      ObjectCreate(0, name, OBJ_HLINE, 0, 0, 0);
   ObjectSetDouble(0, name, OBJPROP_PRICE, 0, price);  //what is needed
   ObjectSetInteger(0, name, OBJPROP_COLOR, Color); // what is needed by us
   ObjectSetInteger(0, name, OBJPROP_STYLE, LineStyle); //input variables
   ObjectSetInteger(0, name, OBJPROP_WIDTH, LineWidth);
   ObjectSetInteger(0, name, OBJPROP_SELECTABLE, false);
  }

//+------------------------------------------------------------------+
//|                                                 |
//+------------------------------------------------------------------+
bool CreateButton(int chart_ID,int x,int y,int width,int height)
  {
//--- reset the error value
   ResetLastError();
//--- create the button
   if(!ObjectCreate(chart_ID,objectname,OBJ_BUTTON,0,0,0))
     {
      Print(__FUNCTION__,
            ": failed to create the button! Error code = ",GetLastError());
      return(false);
     }
//--- set button coordinates
   ObjectSetInteger(chart_ID,objectname,OBJPROP_XDISTANCE,x);
   ObjectSetInteger(chart_ID,objectname,OBJPROP_YDISTANCE,y);
//--- set button size
   ObjectSetInteger(chart_ID,objectname,OBJPROP_XSIZE,width);
   ObjectSetInteger(chart_ID,objectname,OBJPROP_YSIZE,height);
//--- set the chart's corner, relative to which point coordinates are defined
   ObjectSetInteger(chart_ID,objectname,OBJPROP_CORNER,CORNER_RIGHT_UPPER);
//--- set the text

   ObjectSetInteger(chart_ID,objectname,OBJPROP_FONTSIZE,8);

   ObjectSetInteger(chart_ID,objectname,OBJPROP_BACK,false);

//--- enable (true) or disable (false) the mode of moving the button by mouse
   ObjectSetInteger(chart_ID,objectname,OBJPROP_SELECTABLE,false);
   ObjectSetInteger(chart_ID,objectname,OBJPROP_SELECTED,false);
//--- hide (true) or display (false) graphical object name in the object list
   ObjectSetInteger(chart_ID,objectname,OBJPROP_HIDDEN,false);
//----
   SetButtonState(ButtonState);

//--- successful execution
   return(true);

  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void SetButtonState(bool state)
  {

   ButtonState=state;

//--- set button state
   ObjectSetInteger(0,objectname,OBJPROP_STATE,ButtonState);
   ObjectSetString(0,objectname,OBJPROP_TEXT,ButtonText());
//--- set background color
   ObjectSetInteger(0,objectname,OBJPROP_BGCOLOR,ButtonColour());
   ChartRedraw(0);

   string msg=StringFormat("%s-%s",__FUNCSIG__,ButtonText());

  }
//+------------------------------------------------------------------+
//| when button clicked  the text outputed
//+------------------------------------------------------------------+
string ButtonText()
  {
   return(ButtonState ?buttontextrunning:buttontextpause);
  }
//+------------------------------------------------------------------+
//|  when button clicked buttonchanges colour
//+------------------------------------------------------------------+
int ButtonColour()
  {
   return (ButtonState?buttoncolourrunning:buttoncolourrunning);
  }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool IsTradingAllowed()
  {
// the following must all be true
//the following code casting is done meaning turning return typye of int to make it retrun true
//or falsse
   return((bool)MQLInfoInteger(MQL_TRADE_ALLOWED) // TRUE if trading allowed in input dialog
          && (bool)TerminalInfoInteger(TERMINAL_TRADE_ALLOWED)  //true if trading allowed in trerminal
          &&(bool)TerminalInfoInteger(TERMINAL_CONNECTED)
          && (bool)AccountInfoInteger(ACCOUNT_TRADE_EXPERT) //true if ia account able to auto trade
         );

  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool IsMarkertOpen(string symbol,datetime time)
  {

   static string lastsymbol =" ";
   static bool isopen=false;
   static datetime sessionstart=0;
   static datetime sessionend=0;




   if(lastsymbol==symbol && sessionend >sessionstart)
     {
      if((isopen &&time >=sessionstart&&time<sessionend)||(!isopen&&time>sessionstart && time<sessionend))
         return isopen;

     }
   lastsymbol=symbol;


   MqlDateTime mtime;
   TimeToStruct(time,mtime);
   datetime seconds = mtime.hour*3600+mtime.min*60+mtime.sec;

   mtime.hour=0;
   mtime.min=0;
   mtime.sec=0;
   datetime daystart = StructToTime(mtime);
   datetime dayend = daystart+86400;


   datetime fromtime;
   datetime totime;

   sessionstart=daystart;
   sessionend=dayend;

   for(int session =0; ; session++)
     {

      if(!SymbolInfoSessionTrade(symbol,(ENUM_DAY_OF_WEEK)mtime.day_of_week,session,fromtime,totime))
        {
         sessionend=dayend;
         isopen=false;
         return isopen;
        }


      if(seconds<fromtime)
        {
         sessionend=daystart+fromtime;
         isopen=false;
         return isopen;

        }

      if(seconds>totime)
        {
         sessionstart=daystart+totime;
         continue;
        }

      sessionstart=daystart+fromtime;
      sessionend=daystart +totime;
      isopen=true;
      return isopen;

     }
   return false;
  }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool TimeFilter()
  {
 MqlDateTime time;
 TimeLocal(time); ///will filll the structure with right value
 time.sec=0;
 
 //now overide the stucture
 time.hour=startradingtime_in_hours;
 time.min=startradingtime_in_minutes;
 datetime timestart=StructToTime(time);
 
  time.hour=stoptradingtime_in_hours;
 time.min=stoptradingtime_in_minutes;
  datetime timeend=StructToTime(time);
 
 
 bool timerange=TimeLocal()>=timestart&&TimeLocal()<=timeend;
 return timerange;
 
 
  }



//+------------------------------------------------------------------+
//|COUNT SELL POSITIONS                                               |
//+------------------------------------------------------------------+
int NumoFSell()
  {
   int NumoFSell=0;
   for(int i=PositionsTotal()-1; i>=0; i--)
     {
      //#####
      //exclude some trades
      //#####

      ulong positionticket=PositionGetTicket(i);
      if(!PositionSelectByTicket(positionticket)
         &&PositionGetString(POSITION_SYMBOL)!=_Symbol&&PositionGetInteger(POSITION_MAGIC)!=ea_magic)
         continue;
      if(PositionGetInteger(POSITION_TYPE)==POSITION_TYPE_SELL)
        {
         NumoFSell++;
        }
     }
   return(NumoFSell);
  }

//+------------------------------------------------------------------+
//| count num of buy                                                                 |
//+------------------------------------------------------------------+
int NumOfBuy()
  {
   int NumOfBuy=0;
   for(int i=PositionsTotal()-1; i>=0; i--)
     {
      //#####
      //exclude some trades
      //#####

      ulong positionticket=PositionGetTicket(i);
      if(!PositionSelectByTicket(positionticket)
         &&PositionGetString(POSITION_SYMBOL)!=_Symbol&&PositionGetInteger(POSITION_MAGIC)!=ea_magic)
         continue;
      if(PositionGetInteger(POSITION_TYPE)==POSITION_TYPE_BUY)
        {
         NumOfBuy++;
        }
     }
   return(NumOfBuy);
  }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void ClosePositions(ENUM_POSITION_TYPE type)
  {
   ResetLastError();
   for(int i=PositionsTotal()-1; i>=0; i--)
     {
      ulong positionticket=PositionGetTicket(i);
      if(!PositionSelectByTicket(positionticket)
         &&PositionGetString(POSITION_SYMBOL)!=_Symbol&&PositionGetInteger(POSITION_MAGIC)!=ea_magic)
         continue;

      if(type==POSITION_TYPE_BUY)
        {
         if(PositionGetInteger(POSITION_TYPE)==POSITION_TYPE_BUY)
           {
            if(!trade.PositionClose(positionticket))
              {
               Alert("failed to close buy positions sir",GetLastError());
              }
            else
              {
               Alert(NAME+ " CHANGE IN MARKET DIRECTION!!,CLOSED BUY POSITIONS");
              }
           }
        }
      else
         if(type==POSITION_TYPE_SELL)
           {
            if(PositionGetInteger(POSITION_TYPE)==POSITION_TYPE_SELL)
              {
               if(!trade.PositionClose(positionticket))
                 {
                  Print("failed to close sell positions",GetLastError());
                 }
               else
                 {

                  Alert(NAME+" CHANGE IN MARKET DIRECTION!!,CLOSED SELL POSITIONS");
                 }
              }
           }

     }

  }

//+------------------------------------------------------------------+
//|IF THERE IS A POSITION IN MARKET
//+------------------------------------------------------------------+
void DeleteOrders()
  {
   ResetLastError();
   for(int i=OrdersTotal(); i>=0; i--)
     {
      ulong orderticket=OrderGetTicket(i);
      //######
      //exclude orders u dont want
      //#######
      if(!OrderSelect(orderticket)
         &&OrderGetString(ORDER_SYMBOL)!=_Symbol&&OrderGetInteger(ORDER_MAGIC)!=ea_magic)
         continue;

      //####
      //--DELETES ALLL ORDERS IN PRESENCE OF A POSITIONS
      //####


      if(NumOfBuy()>0||NumoFSell()>0)//--have an open positions
         if(!trade.OrderDelete(orderticket))
           {
            Alert("failed to close positions sir",GetLastError());
           }
         else
           {
            Alert(NAME + "HAVE POSITIONS IN MARKET NOW ,I DELETED SOME ORDERS");
           }
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void DeleteBuyOrders()
  {
   ResetLastError();
   for(int i=OrdersTotal(); i>=0; i--)
     {
      ulong orderticket=OrderGetTicket(i);
      //######
      //exclude orders u dont want
      //#######
      if(!OrderSelect(orderticket)
         &&OrderGetString(ORDER_SYMBOL)!=_Symbol&&OrderGetInteger(ORDER_MAGIC)!=ea_magic)
         continue;

      if(OrderGetInteger(ORDER_TYPE)==ORDER_TYPE_BUY_STOP)
        {
         if(!trade.OrderDelete(orderticket))
           {
            Print("failed to close orders on ranging market",GetLastError());
           }
         else
           {
            Alert(NAME +" CLSED BUYS!!,POTENTIAL RANGE COMING");
           }

        }

     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void DeleteSellOrders()
  {
   ResetLastError();
   for(int i=OrdersTotal(); i>=0; i--)
     {
      ulong orderticket=OrderGetTicket(i);
      //######
      //exclude orders u dont want
      //#######
      if(!OrderSelect(orderticket)
         &&OrderGetString(ORDER_SYMBOL)!=_Symbol&&OrderGetInteger(ORDER_MAGIC)!=ea_magic)
         continue;

      if(OrderGetInteger(ORDER_TYPE)==ORDER_TYPE_SELL_STOP)
        {
         if(!trade.OrderDelete(orderticket))
           {
            Print("failed to close orders on ranging market",GetLastError());
           }
         else
           {
            Alert(NAME + " CLSED SELL ORDERS!!,POTENTIAL RANGE COMING");
           }

        }
     }
  }


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int NumOfBuyOrders()
  {
   int NUMOFBUYORDERS=0;
   for(int i=0; i<OrdersTotal() ; i++)
     {
      ulong orderticket=OrderGetTicket(i);
      //######
      //exclude orders u dont want
      //#######
      if(!OrderSelect(orderticket)
         &&OrderGetString(ORDER_SYMBOL)!=_Symbol&&OrderGetInteger(ORDER_MAGIC)!=ea_magic)
         continue;
      if(OrderGetInteger(ORDER_TYPE)==ORDER_TYPE_BUY_STOP)
         NUMOFBUYORDERS++;
     }
   return(NUMOFBUYORDERS);
  }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int NumOfSellOrders()
  {
   int NUMOFSELLORDERS=0;
   for(int i=OrdersTotal(); i>=0; i--)
     {
      ulong orderticket=OrderGetTicket(i);
      //######
      //exclude orders u dont want
      //#######
      if(!OrderSelect(orderticket)
         &&OrderGetString(ORDER_SYMBOL)!=_Symbol&&OrderGetInteger(ORDER_MAGIC)!=ea_magic)
         continue;
      if(OrderGetInteger(ORDER_TYPE)==ORDER_TYPE_SELL_STOP)
         NUMOFSELLORDERS++;
     }
   return(NUMOFSELLORDERS);
  }



//+------------------------------------------------------------------+
//|OPEN TRADE                                                         |
//+------------------------------------------------------------------+
void PlaceBuyOrder()
  {
   if(FindOrder(4,BUY_PRICE))
     {
      return;
     }
   if(CountLossDeals(0,BUY_PRICE)>2)
     {
      return;
     }

   double sl=NormalizeDouble(BUY_PRICE-STP,Digits());
   stop_level=(int)SymbolInfoInteger(_Symbol,SYMBOL_TRADE_STOPS_LEVEL);//minimu distance broker request from client for orders,tp,sl
   spread =(int)SymbolInfoInteger(_Symbol,SYMBOL_SPREAD);

   if(BUY_PRICE-ASK<(stop_level+spread)*_Point)
     {
      Print(__FUNCTION__,">CANNOT PLACE BUY_STOP_ORDER,(INVALID ORDER PRICE)");
      return;
     }


   if(sl>0&&BUY_PRICE-sl<(stop_level-spread)*_Point)
     {
      Print(__FUNCTION__,">CANNOT PLACE BUYl_STOP_ORDER,(INVALID SL PRICE)");
      return;
     }

   double margin;
   if(OrderCalcMargin(ORDER_TYPE_BUY,_Symbol,lot_size,BUY_PRICE,margin)>AccountInfoDouble(ACCOUNT_MARGIN_FREE))
     {
      Print("not enough margin");
      return;
     }




   if(trade.BuyStop(lot_size,BUY_PRICE,_Symbol,sl,0))
     {
      Print("yeahhhh _we got some buy stop placed waiting for filling");
     }
   else
     {
      Print("unable to place pending_buy order.ERROOR: ",trade.ResultRetcodeDescription(),",code  ", trade.ResultRetcode());
     }






  }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void PlaceSellOrder()
  {
   if(FindOrder(5,SELL_PRICE))
     {
      return;
     }
   if(CountLossDeals(1,SELL_PRICE)>2)
     {
      return;
     }



//##############################################################
///handlign erros of invalid prices either of enties or sl and tp

//##############################################################
   double sl=NormalizeDouble(SELL_PRICE+STP,Digits());
   stop_level=(int)SymbolInfoInteger(_Symbol,SYMBOL_TRADE_STOPS_LEVEL);
   spread =(int)SymbolInfoInteger(_Symbol,SYMBOL_SPREAD);

   if(SELL_PRICE-BID>(stop_level-spread)*_Point)
     {
      Print(__FUNCTION__,">CANNOT PLACE SEll_STOP_ORDER,(INVALID ORDER PRICE)");
      return;
     }

   if(sl>0&&SELL_PRICE-sl>(stop_level-spread)*_Point)
     {
      Print(__FUNCTION__,">CANNOT PLACE SEll_STOP_ORDER,(INVALID SL PRICE)");
      return;
     }

   double margin;
   if(OrderCalcMargin(ORDER_TYPE_SELL,_Symbol,lot_size,SELL_PRICE,margin)>AccountInfoDouble(ACCOUNT_MARGIN_FREE))
     {
      Print("not enough margin");
      return;
     }
///########################################################################


   if(trade.SellStop(lot_size,SELL_PRICE,_Symbol,sl,0))
     {
      Print("yeaaah__we got sell stop placed waiting for filling");
     }


  }









//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void BrakeEven()
  {
   ResetLastError();
   for(int i=PositionsTotal()-1; i>=0; i--)
     {
      //###
      //exclude the trades u dont
      //###
      ulong positionticket=PositionGetTicket(i);
      if(!PositionSelectByTicket(positionticket)
         &&PositionGetString(POSITION_SYMBOL)!=_Symbol&&PositionGetInteger(POSITION_MAGIC)!=ea_magic)
         continue;

      double current_price=PositionGetDouble(POSITION_PRICE_CURRENT);
      double Open_price=PositionGetDouble(POSITION_PRICE_OPEN);
      double current_sl=PositionGetDouble(POSITION_SL);

      double WHEN_TO_BREAK=positionInfo.PositionType()==POSITION_TYPE_BUY?Open_price+When_To_Break:Open_price-When_To_Break;


      if(positionInfo.PositionType()==POSITION_TYPE_BUY)
        {
         if(current_sl>=Open_price)
            continue;
        }
      else
        {
         if(current_sl<=Open_price)
            continue;
        }





      double new_sl=positionInfo.PositionType()==POSITION_TYPE_BUY?NormalizeDouble(Open_price+Break_By,Digits()) : NormalizeDouble(Open_price-Break_By,Digits());





      if(positionInfo.PositionType()==POSITION_TYPE_BUY)
        {
         if(current_price>=WHEN_TO_BREAK)
           {
            if(PositionModifyCheck(positionticket,new_sl))
              {
               if(!trade.PositionModify(positionticket,new_sl,positionInfo.TakeProfit()))
                 {
                  Alert("failed to modify for brakeven",GetLastError());
                 }
               else
                 {
                  Print(NAME + " brakeeven is on sir we RISK FREE NOW");
                 }

              }
           }
        }


      if(PositionGetInteger(POSITION_TYPE)==POSITION_TYPE_SELL)
        {
         if(current_price<=WHEN_TO_BREAK)
           {
            if(PositionModifyCheck(positionticket,new_sl))
              {
               if(!trade.PositionModify(positionticket,new_sl,positionInfo.TakeProfit()))
                 {
                  Alert("failed to modify for brakeven",GetLastError());
                 }
               else
                 {
                  Print(NAME + " brakeeven IS ON sir WE RISK Free Now ");
                 }

              }




           }

        }

     }







  }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void TrailingStopLoss()
  {

   ResetLastError();

   for(int i=PositionsTotal()-1; i>=0; i--)
     {
      //###
      //exclude the trades u dont want
      //###
      ulong positionticket=PositionGetTicket(i);
      if(!PositionSelectByTicket(positionticket)
         &&PositionGetString(POSITION_SYMBOL)!=_Symbol&&PositionGetInteger(POSITION_MAGIC)!=ea_magic)
         continue;

      double current_price=PositionGetDouble(POSITION_PRICE_CURRENT);
      double Open_price=PositionGetDouble(POSITION_PRICE_OPEN);
      double current_sl=PositionGetDouble(POSITION_SL);


      TrailPrice=positionInfo.PositionType()==POSITION_TYPE_BUY?current_sl+WHEN_TO_TRAIL:current_sl-WHEN_TO_TRAIL;
      TrailPrice=NormalizeDouble(TrailPrice,Digits());




      modified_sl=NormalizeDouble(current_sl+180,Digits());



      if(positionInfo.PositionType()==POSITION_TYPE_BUY)
        {
         if(current_price>=TrailPrice)
           {
            if(PositionModifyCheck(positionticket,modified_sl))
              {

               if(!trade.PositionModify(positionticket,modified_sl,0))
                 {
                  Alert("failed to set buy trailliing stop",GetLastError());
                 }
               else
                 {
                  Print("succesfully placed buy trailling sl");

                 }
              }
           }
        }
      modified_sl2=NormalizeDouble(current_sl-180,_Digits);


      if(PositionModifyCheck(positionticket,modified_sl2))
        {
         if(positionInfo.PositionType()==POSITION_TYPE_SELL)
           {
            if(current_price<=TrailPrice)
              {
               if(!trade.PositionModify(positionticket,modified_sl2,0))
                 {
                  Alert("failed to set sell trailliing stop",GetLastError());
                 }
               else
                 {
                  Print("succesfully placed  sell trailling sl");

                 }
              }

           }
        }







     }


  }





//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool BearMaCrossOver()
  {
   bool crossover=false;
   if(four_mabuffer[1]<closing_buffer[1]&&eight_mabuffer[1]<closing_buffer[1])
     {
      crossover=true;
     }
   return(crossover);

  }
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool BullMaCrossOver()
  {
   bool crossover=false;
   if(four_mabuffer[1]>closing_buffer[1]&&eight_mabuffer[1]>closing_buffer[1])
     {
      crossover=true;
     }
   return(crossover);
  }
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool ExecuteOnNewBar(bool first_call=false)
  {
   static bool result =false;
   if(!first_call)
      return(result);

   static datetime previous_time=0;
   datetime current_time=iTime(_Symbol,PERIOD_CURRENT,0);
   result =false;

   if(previous_time!=current_time)
     {
      previous_time=current_time;
      result=true;
     }
   return(result);
  }








//+------------------------------------------------------------------+
//#############
//---USED TO IDENTIFY TRENDING CANLDESTICS AND RANGING ONES
//#############
//+------------------------------------------------------------------+
bool BullIsTrending()
  {

   if(macd_buffer[1]>0&&macd_buffer[1]>signal_line[1])
     {
      return true;
     }
   return false;





  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool BearIsTrending()
  {
   if(macd_buffer[1]<0&&macd_buffer[1]<signal_line[1])
     {
      return true;
     }
   return false;





  }


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool FindOrder(int type,double price)
  {
   bool result = false;
   int      total = OrdersTotal();
   ulong    ticket;
//---
   for(int i=total-1; i>=0; i--)
     {
      if((ticket=OrderGetTicket(i))>0)
        {
         if(type!=-1 && OrderGetInteger(ORDER_TYPE)!=type)
            continue;
         if((int)OrderGetInteger(ORDER_MAGIC)!=ea_magic)
            continue;
         if(OrderGetDouble(ORDER_PRICE_OPEN)==price)
           {
            result = true;
            break;
           }
        }
     }
   return(result);
  }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int CountLossDeals(int type,double  price)
  {
   int count = 0;
   double total_profit = 0.0;
   datetime end=TimeCurrent();
   datetime start=0;
   HistorySelect(start,end);
   int deals=HistoryDealsTotal();
   ulong ticket=0;
   for(int i=deals-1; i>=0; i--)
     {
      if((ticket=HistoryDealGetTicket(i))>0)
        {
         if(HistoryDealGetInteger(ticket,DEAL_ENTRY)!=DEAL_ENTRY_OUT)
            break;

         if(HistoryDealGetInteger(ticket,DEAL_MAGIC)==ea_magic)
           {
            if(HistoryDealGetInteger(ticket,DEAL_TYPE)!=(type==0?1:0))
               continue;
            long position_ticket = HistoryDealGetInteger(ticket,DEAL_POSITION_ID);
            double PO = 0.0;
            if(OrderGetInfo(position_ticket,PO))
              {
               if(PO!=price)
                 {
                  break;
                 }
              }
            double profit = HistoryDealGetDouble(ticket,DEAL_PROFIT)+HistoryDealGetDouble(ticket,DEAL_SWAP)+HistoryDealGetDouble(ticket,DEAL_COMMISSION);
            if(profit<0.0)
              {
               count++;
              }
            else
              {
               break;
              }
           }
        }
     }
   return(count);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool OrderGetInfo(long t, double &value)
  {
   datetime end=TimeCurrent();
   datetime start=0;
   HistorySelect(start,end);
   int deals=HistoryDealsTotal();
   ulong ticket=0;
   for(int i=deals-1; i>=0; i--)
     {
      if((ticket=HistoryDealGetTicket(i))>0)
        {
         if(HistoryDealGetInteger(ticket,DEAL_ENTRY)!=DEAL_ENTRY_IN)
            continue;
         if(HistoryDealGetInteger(ticket,DEAL_POSITION_ID)!=t)
            continue;
         value = HistoryDealGetDouble(ticket,DEAL_PRICE);
         return(true);
        }
     }
   return(false);
  }
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
bool PositionModifyCheck(ulong ticket,double sl)
  {
//--- select order by ticket
   if(positionInfo.SelectByTicket(ticket))
     {
      //--- point size and name of the symbol, for which a pending order was placed
      string symbol=positionInfo.Symbol();
      double point=SymbolInfoDouble(symbol,SYMBOL_POINT);

      //--- check if there are changes in the StopLoss level
      bool StopLossChanged=(MathAbs(positionInfo.StopLoss()-sl)>point);



      //--- if there are any changes in levels
      if(StopLossChanged)

         return(true);  // position can be modified

      //--- there are no changes in the StopLoss and Takeprofit levels
      else

         //--- notify about the error
         PrintFormat("Order #%d already has levels of Open=%.5f SL=%.5f TP=%.5f",
                     ticket,orderinfo.PriceOpen(),orderinfo.StopLoss(),orderinfo.TakeProfit());
     }
//--- came to the end, no changes for the order
   return(false);       // no point in modifying
  }










//+------------------------------------------------------------------+
